Options[ScanConfocalImage]=
	{CountingTime->0.003,SettlingTime->0.001,BacktraceTime->(10#&),ZigZagScan->False,
		ImageMergingFunction->Total,TiltCorrection->False,OptimizeCounterWaitingTime->True,
		PreviewFunction->(PlotConfocalImage[ReplacePart[#1[[1]],1->Total[#1[[All,1]]]]]&)};
ScanConfocalImage[xAxis:1|2|3,xmin_?NumericQ,xmax_?NumericQ,nx_Integer?Positive,
		yAxis:1|2|3,ymin_?NumericQ,ymax_?NumericQ,ny_Integer?Positive,z_?NumericQ,
		options:OptionsPattern[]]:=
	$ODMRLockLink[
		Module[{x0,y0,z0,dt0,dt=OptionValue[CountingTime],st=OptionValue[SettlingTime],
			bt=OptionValue[BacktraceTime],zAxis=Complement[{1,2,3},{xAxis,yAxis}][[1]],
			abort=False,imageData=ConstantArray[0,{ny,nx,$ODMRnumCounters}],
			zigZag=OptionValue[ZigZagScan],
			i=0,y,dz,previewFunction=OptionValue[PreviewFunction],
			mergingFunction=OptionValue[ImageMergingFunction],
			tiltCorrection=(#/.False->None)&/@
				Switch[#,{(_?NumericQ)|False|None,(_?NumericQ)|False|None},#,
					(_?NumericQ)|False|None,{#,#},_,{None,None}]&@
				OptionValue[TiltCorrection],
			orderAxes,
			generateImagesFromData=Function[data,
				Switch[{xAxis,yAxis},{2,1}|{3,1|2},TransposeConfocalImage[#],_,#]&
				@ConfocalImage[#,{"area"->{xmax-xmin,ymax-ymin}*10^-6,
					"offset"->{xmin,ymin}*10^-6,{"X","Y","Z"}[[Complement[Range[3],
						{xAxis,yAxis}][[1]]]]->z},""]&/@Transpose[data,{2,3,1}]],
			scanFunction},
			If[Head[bt]===Function,bt=bt[st]];
			scanFunction=If[OptionValue[OptimizeCounterWaitingTime]===True,
				ODMRScanLine[##,N@dt]&,ODMRScanLine];
			{x0,y0,z0}=MCLSingleReadXYZ[$ODMRstage];
			dt0=GetCounterCountingTime[];
			SetCounterCountingTime[dt];
			orderAxes=Function[axes,Function[xyz,#[[2]]&/@SortBy[Transpose[{axes,xyz}],First]]]@
				{xAxis,yAxis,zAxis};
			Monitor[
				For[i=1,i<=ny,i++,
					y=ymin+(i-1/2)*(ymax-ymin)/ny;
					dz=If[NumericQ[#],(y-(ymin+ymax)/2)*Tan[#],0]&@tiltCorrection[[2]];
					If[abort,Break[]];
					imageData[[i]]=Module[{d=If[zigZag,2Mod[i,2]-1,1]},
						If[d<0,Reverse[#],#]&@
						If[NumericQ[#],
							scanFunction[$ODMRstage,$ODMRcounter,
								N@orderAxes@{xmin+(xmax-xmin)/(2*nx),
									y,z+dz-(xmax-xmin)/2*Tan[#]},
								N@orderAxes@{xmax-(xmax-xmin)/(2*nx),
									y,z+dz+(xmax-xmin)/2*Tan[#]},
								nx,N@If[zigZag,st,bt],N@st],
							scanFunction[$ODMRstage,$ODMRcounter,
								xAxis,
								Sequence@@(If[d<0,Reverse[#],#]&[
									N@{xmin+(xmax-xmin)/(2*nx),
										xmax-(xmax-xmin)/(2*nx)}]),
								nx,
								Sequence@@(
									N@Switch[{xAxis,yAxis},
										{1,2}|{2,3}|{3,1},{y,z+dz},
										{2,1}|{3,2}|{1,3},{z+dz,y}]),
								N@If[zigZag,st,bt],N@st],
						]&@tiltCorrection[[1]]/dt]
				],{Button["abort",abort=True],
					previewFunction[generateImagesFromData[imageData],i/ny]}];
			SetCounterCountingTime[dt0];
			MCLSingleWriteXYZ[{x0,y0,z0},$ODMRstage];
			Function[images,$ODMRlastConfocalImage=
				If[mergingFunction=!=Null,
					MapAt[Map[mergingFunction,Transpose[First/@images,{3,1,2}],{2}]&,
						images[[1]],1],
					images]]@generateImagesFromData[imageData]
		]]/;xAxis!=yAxis;
CropConfocalImage[a_ConfocalImage,newOffset:{_?NumericQ,_?NumericQ},
		newArea:{_?NumericQ,_?NumericQ}]:=
	Module[{newOffsetC,newAreaC,offset,off,area,dims = Reverse@Dimensions@a[[1]]},
		{offset,area}=1*^6{"offset","area"}/.a[[2]];
		newOffsetC=Clip[#[[2]]+Ceiling[#[[1]]-#[[2]],#[[3]]/#[[4]]],#[[2]]+{0, #[[3]]}]&
			/@Transpose[{newOffset,offset,area,dims}];
		newAreaC=Clip[#[[2]]+Floor[#[[1]]-#[[2]],#[[3]]/#[[4]]],#[[2]]+{0,#[[3]]}]&
			/@Transpose[{newOffset+newArea,offset,area,dims}]-newOffsetC;
		off=newOffsetC-offset;
		MapIndexed[
			Switch[#2[[1]],
				1,Take[Drop[#,Round[(off/area)[[1]]Length[#]]],
						Round[(newAreaC/area)[[1]]*Length[#]]]&
					/@Take[
						Drop[#,Round[(off/area)[[2]]Length[#]]],
						Round[(newAreaC/area)[[2]]*Length[#]]],
				2,#1/.{("offset"->_)->("offset"->1*^-6*newOffsetC),
					("area"->_)->("area"->1*^-6*newAreaC),
					("pixels"->l_):>("pixels"->(l-{1,1})*newAreaC/area+{1,1})},
				_,#1]&,a]
	];
TransposeConfocalImage[a_ConfocalImage]:=
	MapIndexed[Switch[#2[[1]],
		1,Transpose[#1],
		2,#1/.r:("area"|"offset"->{_,_}):>MapAt[Reverse,r,2],_,#1]&,a];

Options[PlotConfocalImage]=Join[{MinCounts->Min,MaxCounts->Max,
		ColorFunction->(ColorData["SunsetColors"][Clip[#1,{0,1}]]&),
		ColorScaleFunction->Identity,ColorSteps->100},Options[Graphics]];
PlotConfocalImage[data_ConfocalImage?ConfocalImageQ,options:OptionsPattern[]]:=
	Function[{imageData,dataUnit,offset,area,lengthUnit,axes,min,max},
		Module[{cf=Function[{f,g,h},f[g[h[#1]]]&][OptionValue[ColorFunction],
					OptionValue[ColorScaleFunction],If[min!=max,(#-min)/(max-min)&,1/2&]]},
			{Graphics[Raster[Map[List@@cf[#]&,imageData,{2}],{offset,offset+area}],
				Sequence@@FilterRules[{options},Options@Graphics],
				ImageSize->96/25.4*100,Frame->True,
				FrameLabel->({"x","y","z"}[[#]]<>"("<>lengthUnit<>")"&/@axes)],
			ConfocalImageColorLegend[{min,max},ColorFunction->cf,BarLabel->dataUnit,
				ColorSteps->OptionValue[ColorSteps]]}]
	][1*^-3*#1,"kCounts",1*^6*#2,1*^6*#3,"\[Mu]m",#4,
	1*^-3*Function[{f,d},If[NumericQ[f],f,f[d]]][OptionValue[MinCounts],#1],
	1*^-3*Function[{f,d},If[NumericQ[f],f,f[d]]][OptionValue[MaxCounts],#1]]&[
		#[[1]],"offset"/.#[[2]],"area"/.#[[2]],Complement[Range[3],
			Cases[#[[2]],(x:("X"|"Y"|"Z")->_):>Position[{"X","Y","Z"},x][[1,1]]]]]&[data];
PlotConfocalImage[data:_Graphics|{_Graphics,_Graphics}?ConfocalImageQ,
		options:OptionsPattern[]]:=
	PlotConfocalImage[ExtractConfocalImage[data],options];
PlotConfocalImage[data:{__?ConfocalImageQ},options:OptionsPattern[]]:=
	PlotConfocalImage[#,options]&/@data;
Options[ConfocalImageColorLegend]=
	{AspectRatio->10,BarLabel->None,ColorSteps->100,RasterColorMap->False,
			ColorFunction->Automatic};
ConfocalImageColorLegend[r:_?NumericQ|{_?NumericQ,_?NumericQ},o:OptionsPattern[]]:=
	Module[{range=If[Length[r]==2,r,{0,r}],ar=OptionValue[AspectRatio],
			steps=OptionValue[ColorSteps],cf=OptionValue[ColorFunction],
			rasterColorMap=OptionValue[RasterColorMap],nullRange},
		If[nullRange=range[[1]]==range[[2]],range={0,1}];
		If[cf===Automatic,cf=If[nullRange,Black&,
			ColorData["SunsetColors"][(#-range[[1]])/(range[[2]]-range[[1]])]&]];
		Graphics[If[rasterColorMap,
			Inset[ImageResize[Image[#,FilterRules[{o},Options@Image]],steps{1/ar,1}],
				{0,range[[1]]},{0,0},{1,range[[2]]-range[[1]]}],#]&
			@Raster[Transpose@{List@@cf[#]&
					/@Module[{dr=(range[[2]]-range[[1]])/steps},Range[range[[1]]+dr/2,range[[2]]-dr/2,dr]]},
				Transpose@{{0,1},range}],FilterRules[{o},Options@Graphics],
			PlotRange->{{0,1},range},Frame->True,FrameTicks->{{None,All},{None,None}},
			FrameLabel->{{None,OptionValue[BarLabel]},{None,None}},PlotRangePadding->None,
			ImageMargins->None,ImagePadding->Automatic,AspectRatio->ar]
	];
Options[ExtractConfocalImage]={ZValue->0};
ExtractConfocalImage[{data:Graphics[_Raster|{___,_Raster,___},___],
		Graphics[Raster[{{{_,_,_}}..},{{0,low_},{1,high_}}],___]},
		options:OptionsPattern[]]:=
	ExtractConfocalImage[data,10^3 {low,high},options];
ExtractConfocalImage[
		Graphics[Raster[data:{{{_,_,_}..}..},range:{{_,_},{_,_}}]|
				{___,Raster[data:{{{_,_,_}..}..},range:{{_,_},{_,_}}],___},gOptions___],
		scale:{_,_},options:OptionsPattern[]]:=
	Module[{zAxis=Complement[{"X","Y","Z"},
				Switch[#,"x(\[Mu]m)","X","y(\[Mu]m)","Y","z(\[Mu]m)","Z"]&
				/@(FrameLabel/.Flatten[{gOptions}]
					/.FrameLabel->{"x(\[Mu]m)","y(\[Mu]m)"})][[1]],
			x,y,g},
		g=Function[#1,(1-#2)scale[[1]]+#2 scale[[2]]]&[y,
			MapIndexed[Switch[#2[[1]],
				1,{x/.Solve[#[[1]]==y,x][[1]],
					#[[2]]/.{q_?NumberQ:>(#[[1]]/.x->q),x->y}}&/@#1,
				2,x/.Solve[#1==y,x][[1]]]&,#]&
			@Simplify@Function[{f,p,x},
				Piecewise[{((#[[2]]-x)f[#[[1]]]+(x-#[[1]])f[#[[2]]])/(#[[2]]-#[[1]]),
					#[[1]]<=x<#[[2]]}&/@#,x]&
				@Transpose[{Drop[#,-1],Drop[#,1]}]&@Sort[p]
			][ColorData["SunsetColors"][#][[2]]&,Range[0,1,1/6],x]];
		ConfocalImage[Map[g[#[[2]]]&,data,{2}],
			{"offset"->1*^-6*range[[1]],"area"->1*^-6*(range[[2]]-range[[1]]),
				zAxis->OptionValue[ZValue]},""]];
ExtractConfocalImage[g_Graphics,options:OptionsPattern[]]:=
	ExtractConfocalImage[g,{0,1},options];
ExtractConfocalImage[l_List,a___]:=ExtractConfocalImage[#,a]&/@l;
ResampleConfocalImage[data_ConfocalImage,newResolution:{_Integer?Positive,_Integer?Positive}]:=
	MapAt[Module[{dims=Dimensions[#],tDims=Reverse@newResolution,
				shift=Floor[(Reverse@newResolution-1)/2]}, 
			Sqrt[Times@@tDims/Times@@dims]*Abs@InverseFourier@
			RotateLeft[PadRight[RotateRight[Fourier[#],shift],tDims],shift]]&,data,1];
ResampleConfocalImage[data:(_Graphics|{__Graphics}),z___]:=
	PlotConfocalImage@ResampleConfocalImage[ExtractConfocalImage[data],z];
ResampleConfocalImage[data_List,z___]:=ResampleConfocalImage[#,z]&/@data;
Options[SaveConfocalImage]=
	Join[{FileNamePrefix:>FileNameJoin[{NotebookDirectory[],"confocalScan"}]},
		Options[ExtractConfocalImage]];
SaveConfocalImage[g:{_Graphics,_Graphics},options:OptionsPattern[]]:=
	Module[{axesNames={"X","Y","Z"},axes,zAxis,
			image=ExtractConfocalImage[g,Sequence@@FilterRules[{options},
				Options@ExtractConfocalImage]]},
		zAxis=Cases[image[[2]],
			(axis:(Alternatives@@axesNames)->axisValue_):>
				{Position[axesNames,axis][[1,1]],axisValue}][[1]];
		axes=Transpose[{Complement[Range[3],{zAxis[[1]]}],
			Transpose[10^6 {#1,#1+#2}]&@@({"offset","area"}/.image[[2]])}];
		Export[OptionValue[FileNamePrefix]<>"_"
			<>StringJoin[axesNames[[#[[1]]]]
				<>StringJoin@Riffle[ToString/@#[[2]],"to"]<>"_"&/@axes]
			<>axesNames[[zAxis[[1]]]]
			<>ToString[zAxis[[2]]]<>".csv",image[[1]],"CSV"]];
ScanConfocalVolume[xmin_?NumericQ,xmax_?NumericQ,
		nx_Integer?Positive,ymin_?NumericQ,ymax_?NumericQ,ny_Integer?Positive,zmin_?NumericQ,zmax_?NumericQ,
		nz_Integer?Positive,dt_?Positive,st_?NonNegative,o:OptionsPattern[]]:=
	$ODMRLockLink[Module[{x0,y0,z0,dt0,ig=0,data,btt=BackTraceTime/.{o}/.BackTraceTime->10st},
			{x0,y0,z0}=MCLSingleReadXYZ[$ODMRstage];
		MCLSingleWriteXYZ[{xmin,ymin,zmin},$ODMRstage];
			dt0=GetCounterCountingTime[];
			SetCounterCountingTime[dt];
			If[Head[btt]===Function,btt=btt[st]];
			data=Monitor[
				Function[{z,i},
					ig=i;
					Transpose@ODMRScanArea[$ODMRstage,$ODMRcounter,
2,N@ymin,N@ymax,ny,1,N@xmin,N@xmax,nx,N@z,N@btt,N@btt,N@st]/dt
				]@@#&/@Transpose[{#,Range[Length[#]]}]&
				@Range[zmin,zmax,(zmax-zmin)/(nz-1)],ProgressIndicator[ig/ny]];
			SetCounterCountingTime[dt0];
			MCLSingleWriteXYZ[{x0,y0,z0},$ODMRstage];
			data
		]
	];
ConfocalImageColorLegendQ[g_]:=
	MatchQ[g,Graphics[
		Inset[_Image?(MatchQ[{ImageDimensions[#],ImageType[#],
			ImageChannels[#]},{{1,_},"Real",3}]&),{0,_},{0,_},{1,_}]| 
		Raster[_List?(MatchQ[Dimensions[#],{_,1,3}]&),{{0,_},{1,_}}],___]];
ConfocalImageQ[x_]:=
  MatchQ[x,ConfocalImage[_?(ArrayQ[#,2,NumericQ]&),
			{__Rule}?(Function[l,And@@(MemberQ[l,#]&/@{
					"offset"->{_?NumericQ,_?NumericQ},"area"->{_?NumericQ,_?NumericQ},
					("X"|"Y"|"Z")->(_?NumericQ)})]),___]| 
		Graphics[Raster[_List,{{_?NumericQ,_?NumericQ},{_?NumericQ,_?NumericQ}}]|
			{___,Raster[_List,{{_?NumericQ,_?NumericQ},{_?NumericQ,_?NumericQ}}], ___}, ___]|
		{_Graphics?ConfocalImageQ,_?ConfocalImageColorLegendQ}];
GetConfocalImageOrigin[c_ConfocalImage?ConfocalImageQ]:=(10^6*"offset"/.c[[2]]);
GetConfocalImageOrigin[g_Graphics?ConfocalImageQ]:=
	Cases[g,Raster[_List,range_List]:>First@range,\[Infinity]][[1]];
GetConfocalImageOrigin[g:{_Graphics,_Graphics}?ConfocalImageQ]:=GetConfocalImageOrigin[g[[1]]];
GetConfocalImageArea[c_ConfocalImage?ConfocalImageQ]:=(10^6*"area"/.c[[2]]);
GetConfocalImageArea[g_Graphics?ConfocalImageQ]:=
	Cases[g,Raster[_List,range_List]:>(#[[2]]-#[[1]]&/@Transpose@range),
		\[Infinity]][[1]];
GetConfocalImageArea[g:{_Graphics,_Graphics}?ConfocalImageQ]:=
	GetConfocalImageArea[g[[1]]];
GetConfocalImageRange[c_ConfocalImage?ConfocalImageQ]:=
	{0,#[[2]]}+#[[1]]&/@Transpose[10^6*{"offset","area"}/.c[[2]]];
GetConfocalImageRange[g_Graphics?ConfocalImageQ]:=
	Cases[g,Raster[_List,range_List]:>Transpose@range,\[Infinity]][[1]];
GetConfocalImageRange[g:{_Graphics,_Graphics}?ConfocalImageQ]:=
	GetConfocalImageRange[g[[1]]];
GetConfocalImageDimensions[c_ConfocalImage?ConfocalImageQ]:=
	Reverse@Dimensions[c[[1]]];
GetConfocalImageDimensions[g_Graphics?ConfocalImageQ]:=
	Cases[g,Raster[data_List,_List]:>Dimensions[data][[{2, 1}]],\[Infinity]][[1]];
GetConfocalImageDimensions[g:{_Graphics,_Graphics}?ConfocalImageQ]:=
	GetConfocalImageDimensions[g[[1]]];
GetConfocalImageResolution[c_?ConfocalImageQ]:=
	GetConfocalImageArea[c]/GetConfocalImageDimensions[c];
GetConfocalImageAxes[c_ConfocalImage?ConfocalImageQ]:=
	Complement[Range[3],{GetConfocalImageNormalAxis[c]}];
GetConfocalImageAxes[g_Graphics?ConfocalImageQ]:=
	Switch[#,"x(\[Mu]m)",1,"y(\[Mu]m)",2,"z(\[Mu]m)",3]&/@
		(FrameLabel/.Options[g,FrameLabel]);
GetConfocalImageAxes[g:{_Graphics,_Graphics}?ConfocalImageQ]:=
	GetConfocalImageAxes[g[[1]]];
GetConfocalImageNormalAxis[c_ConfocalImage?ConfocalImageQ]:=
	Cases[c[[2]],
		HoldPattern[x:("X"|"Y"|"Z")->_]:>Switch[x,"X",1,"Y",2,"Z",3]][[1]];
GetConfocalImageNormalAxis[g_Graphics?ConfocalImageQ]:=
	Complement[Range[3],GetConfocalImageAxes[g]][[1]];
GetConfocalImageNormalAxis[g:{_Graphics,_Graphics}?ConfocalImageQ]:=
	GetConfocalImageNormalAxis[g[[1]]];
GetConfocalImageNormalAxisValue[c_ConfocalImage?ConfocalImageQ]:=
	Cases[c[[2]],HoldPattern[("X"|"Y"|"Z")->x_]:>x][[1]];
GetConfocalImageNormalAxisValue[g_Graphics?ConfocalImageQ]:=Indeterminate;
GetConfocalImageNormalAxisValue[g:{_Graphics,_Graphics}?ConfocalImageQ]:=
	GetConfocalImageNormalAxisValue[g[[1]]];
ListMax[l_List,f_:Identity]:=
	Module[{i,n=Length[l],imax=0,vmax=-\[Infinity],v},
		For[i=1,i<=n,i++,v=f[l[[i]]];If[v>vmax,imax=i;vmax=v]]; 
		If[imax>0,{imax,l[[imax]]},{0, -\[Infinity]}]];
CroppedMapIndexed[f_,l_List]:=MapIndexed[f,l];
CroppedMapIndexed[f_,l_List,{a_Integer,b_Integer}]:=
	Module[{imax=Min[b,Length[l]]},
		First@NestWhile[{ReplacePart[#[[1]],#[[2]]->f[#[[1,#[[2]]]],{#[[2]]}]],
			#[[2]]+1}&,
			{l,Max[a,1]},#[[2]]<=imax&]];
CroppedMapIndexed[f_,l_List,a:{_,_},b:({_,_}..)]:=
	CroppedMapIndexed[Function[{x,p},
		CroppedMapIndexed[Function[{y,q},f[y,Join[p,q]]],x,b]],l,a];

